<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>FunDemo</title>
</head>

<body>
    <script>

        function displayPersonInfo(
            firstName = 'Marek',
            lastName = 'Lints',
            personalCode = '123'
        ) {
            let personText = 'Eesnimi: ' + firstName;
            personText = personText + '; Perenimi: ' + lastName;
            personText = personText + '; Isikukood: ' + personalCode;
            console.log(personText);
        }

        function extractPersonBirthYear(personalCode) {
            // 3 - 20. saj. sündinud mees
            // 81 - sünniaasta sajandi sees
            // 04 - sünnikuu
            // 24 - sünni kuupäev

            // '381245345654'.substr(1, 3)
            const firstDigit = personalCode.substr(0, 1);
            console.log(firstDigit); // Arendajate tööriist vahetulemuse testimiseks.
            const birthYear = personalCode.substr(1, 2);
            console.log(birthYear);

            // if (firstDigit == '1' || firstDigit == '2') {
            //     return 1800 + parseInt(birthYear);
            // } else if (firstDigit == '3' || firstDigit == '4') {
            //     return 1900 + parseInt(birthYear);
            // } else if (firstDigit == '5' || firstDigit == '6') {
            //     return 2000 + parseInt(birthYear);
            // } else if (firstDigit == '7' || firstDigit == '8') {
            //     return 2100 + parseInt(birthYear);
            // } else {
            //     return -1; // Mingi jama sisendiga.
            // }

            switch (firstDigit) {
                case '1':
                case '2':
                    return 1800 + parseInt(birthYear);
                case '3':
                case '4':
                    return 1900 + parseInt(birthYear);
                case '5':
                case '6':
                    return 2000 + parseInt(birthYear);
                case '7':
                case '8':
                    return 2100 + parseInt(birthYear);
                default:
                    return -1;
            }
        }

        function extractPersonGender(personalCode) {
            const firstDigit = personalCode.substr(0, 1);
            // switch (firstDigit) {
            //     case '1':
            //     case '3':
            //     case '5':
            //     case '7':
            //         return 'Mees';
            //     case '2':
            //     case '4':
            //     case '6':
            //     case '8':
            //         return 'Naine';
            //     default:
            //         return 'VIGA!';
            // }

            // if (parseInt(firstDigit) >= 9 || parseInt(firstDigit) == 0) {
            //     return -1;
            // } else if (parseInt(firstDigit) % 2 == 0) {
            //     return 'Naine';
            // } else {
            //     return 'Mees';
            // }

            if (parseInt(firstDigit) >= 9 || parseInt(firstDigit) == 0 || !/^[\d]+$/.test(firstDigit)) {
                return 'VIGA!';
            } else {
                return (parseInt(firstDigit) % 2 == 1) 
                    ? 'Mees' 
                    : 'Naine';
            }
        }
        // caret (^): <ALT GR> + ä + <space> EESTI KLAVIATUUR
        // caret (^): <SHIFT> + 6 USA KLAVIATUUR
    </script>
</body>

</html>